/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of HyperLogLog.xs. Do not edit this file, edit HyperLogLog.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Algorithm/HyperLogLog.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "murmur3.h"

#define MAGIC 1
#define HLL_HASH_SEED 313

typedef struct HyperLogLog {
    uint32_t m;         /// register num
    uint8_t k;          /// register bit width 
    uint8_t* registers;
    double alphaMM;     /// alpha * m^2
}*HLL;

#define GET_HLLPTR(x) get_hll(aTHX_ x, "$self")

static const double two_32 = 4294967296.0;
static const double neg_two_32 = -4294967296.0;

/**
 * Extract pointer of struct HyperLogLog from SV.
 * 
 * @param[in]   object  Perl object
 * @param[in]   context
 */
static HLL get_hll(pTHX_ SV* object, const char* context) {
    SV *sv;
    IV address;

    if (MAGIC) SvGETMAGIC(object);
    if (!SvROK(object)) {
        if (SvOK(object)) croak("%s is not a reference", context);
        croak("%s is undefined", context);
    }
    sv = SvRV(object);
    if (!SvOBJECT(sv)) croak("%s is not an object reference", context);
    if(!sv_derived_from(object,"Algorithm::HyperLogLog")) {
        croak("%s is not a Algorithm::HyperLogLog", context);
    }
    address = SvIV(sv);
    if (!address)
    croak("Algorithm::HyperLogLog object %s has a NULL pointer", context);
    return INT2PTR(HLL, address);
}

/**
 *  Initialize struct HyperLogLog
 *  
 *  @param[in]  k   paramater for determining register size
 *  @return     pointer of the intialized HLL
 */
static inline HLL initialize_hll(pTHX_ uint32_t k){
    HLL hll = NULL;
    double alpha = 0.0;
    New(__LINE__, hll, 1, struct HyperLogLog);
    if( k < 4 || k > 16 ) {
        croak("Number of ragisters must be in the range [4,16]");
    }
    hll->k = k;
    hll->m = 1 << hll->k;
    Newxz(hll->registers, hll->m, uint8_t);
    switch (hll->m) {
        case 16:
        alpha = 0.673;
        break;
        case 32:
        alpha = 0.697;
        break;
        case 64:
        alpha = 0.709;
        break;
        default:
        alpha = 0.7213/(1.0 + (1.079/(double) hll->m));
        break;
    }
    hll->alphaMM = alpha * hll->m * hll->m;
    return hll;
}


/**
 * Returns position of the leftmost 1-bit of x.
 * 
 * @param[in]   x   target of search 1-bit
 * @param[in]   b   bit width
 * @return      position of the leftmost 1-bit of x
 */
static inline uint8_t rho(uint32_t x, uint8_t b) {
    uint8_t v = 1;
    while (v <= b && !(x & 0x80000000)) {
        v++;
        x <<= 1;
    }
    return v;
}

#line 110 "lib/Algorithm/HyperLogLog.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 254 "lib/Algorithm/HyperLogLog.c"

XS_EUPXS(XS_Algorithm__HyperLogLog_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, k");
    {
	HLL	RETVAL;
	const char *	klass = (const char *)SvPV_nolen(ST(0))
;
	uint32_t	k = (uint32_t)SvUV(ST(1))
;
#line 108 "lib/Algorithm/HyperLogLog.xs"
{
    RETVAL = initialize_hll(aTHX_ k);
}
#line 272 "lib/Algorithm/HyperLogLog.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, klass, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog__new_from_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog__new_from_dump)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "klass, k, data");
    {
#line 118 "lib/Algorithm/HyperLogLog.xs"
uint32_t i;
uint32_t len = 0;
#line 294 "lib/Algorithm/HyperLogLog.c"
	HLL	RETVAL;
	const char *	klass = (const char *)SvPV_nolen(ST(0))
;
	uint32_t	k = (uint32_t)SvUV(ST(1))
;
	AV*	data;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    data = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Algorithm::HyperLogLog::_new_from_dump",
				"data");
		}
	} STMT_END
;
#line 121 "lib/Algorithm/HyperLogLog.xs"
{
    RETVAL = initialize_hll(aTHX_ k);
    len = av_len(data);
    for(i = 0;i <= len;++i){
        RETVAL->registers[i] = (uint8_t)SvUV(*av_fetch(data, i, 0));
    }
}
#line 323 "lib/Algorithm/HyperLogLog.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, klass, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog__dump_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog__dump_register)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	AV *	RETVAL;
	HLL	self = GET_HLLPTR(ST(0))
;
#line 135 "lib/Algorithm/HyperLogLog.xs"
{
    RETVAL = (AV*)sv_2mortal((SV*)newAV());
    uint32_t i;
    for(i = 0;i < self->m; i++){
        av_push(RETVAL, newSVuv(self->registers[i]));
    }
}
#line 353 "lib/Algorithm/HyperLogLog.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog_register_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_register_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	uint32_t	RETVAL;
	dXSTARG;
	HLL	self = GET_HLLPTR(ST(0))
;
#line 149 "lib/Algorithm/HyperLogLog.xs"
    RETVAL = self->m;
#line 378 "lib/Algorithm/HyperLogLog.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 157 "lib/Algorithm/HyperLogLog.xs"
    uint32_t hash;
    uint32_t index;
    uint8_t rank;
    I32 arg_index;
    STRLEN n_a;
#line 398 "lib/Algorithm/HyperLogLog.c"
	HLL	self = GET_HLLPTR(ST(0))
;
#line 163 "lib/Algorithm/HyperLogLog.xs"
{
    if(items > 1){
        for(arg_index = 1; arg_index < items; ++arg_index){
            char* str = SvPV(ST(arg_index), n_a);
            MurmurHash3_32((void *) str, strlen(str), HLL_HASH_SEED, (void *) &hash);
            index = (hash >> (32 - self->k));
            rank = rho( (hash << self->k), 32 - self->k );
            if( rank > self->registers[index] ) {
                self->registers[index] = rank;
            }
        }
    }
}
#line 415 "lib/Algorithm/HyperLogLog.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__HyperLogLog_estimate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_estimate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	double	RETVAL;
	dXSTARG;
	HLL	self = GET_HLLPTR(ST(0))
;
#line 182 "lib/Algorithm/HyperLogLog.xs"
{
    double estimate;
    uint32_t m = self->m;
    uint32_t i = 0;
    double sum = 0.0;
    // Calculate hermonic mean
    for (i = 0; i < m; i++) {
        sum += 1.0/pow(2.0, self->registers[i]);
    }
    estimate = self->alphaMM/sum; // E in the original paper
    if( estimate <= 2.5 * m ) {
        uint32_t zeros = 0;// V in the original paper
        uint32_t i = 0;
        for (i = 0; i < m; i++) {
            if (self->registers[i] == 0) {
                zeros++;
            }
        }
        if( zeros != 0 ) {
            estimate = m * log((double)m/zeros);
        }
    } else if (estimate > (1.0/30.0) * two_32) {
        estimate = neg_two_32 * log(1.0 - ( estimate/two_32 ) );
    }

    RETVAL = estimate;
}
#line 460 "lib/Algorithm/HyperLogLog.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog_merge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_merge)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	double	RETVAL;
	dXSTARG;
	HLL	self = GET_HLLPTR(ST(0))
;
	HLL	other = GET_HLLPTR(ST(1))
;
#line 217 "lib/Algorithm/HyperLogLog.xs"
{
    uint32_t m = self->m;
    uint32_t i = 0;

    if (m != other->m) {
        croak("hll size mismatch: %d != %d\n", m, other->m);
    }

    for (i = 0; i < m; i++) {
        if (self->registers[i] < other->registers[i]) {
            self->registers[i] = other->registers[i];
        }
    }
    XSRETURN_UNDEF;
}
#line 496 "lib/Algorithm/HyperLogLog.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__HyperLogLog_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__HyperLogLog_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HLL	self = GET_HLLPTR(ST(0))
;
#line 239 "lib/Algorithm/HyperLogLog.xs"
{
    Safefree(self->registers);
    Safefree (self);
}
#line 517 "lib/Algorithm/HyperLogLog.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Algorithm__HyperLogLog); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Algorithm__HyperLogLog)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Algorithm::HyperLogLog::new", XS_Algorithm__HyperLogLog_new);
        newXS_deffile("Algorithm::HyperLogLog::_new_from_dump", XS_Algorithm__HyperLogLog__new_from_dump);
        newXS_deffile("Algorithm::HyperLogLog::_dump_register", XS_Algorithm__HyperLogLog__dump_register);
        newXS_deffile("Algorithm::HyperLogLog::register_size", XS_Algorithm__HyperLogLog_register_size);
        newXS_deffile("Algorithm::HyperLogLog::add", XS_Algorithm__HyperLogLog_add);
        newXS_deffile("Algorithm::HyperLogLog::estimate", XS_Algorithm__HyperLogLog_estimate);
        newXS_deffile("Algorithm::HyperLogLog::merge", XS_Algorithm__HyperLogLog_merge);
        newXS_deffile("Algorithm::HyperLogLog::DESTROY", XS_Algorithm__HyperLogLog_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

